import { __extends } from "tslib";
import { DescribeSecurityGroupRulesRequest, DescribeSecurityGroupRulesResult } from "../models/models_3";
import { deserializeAws_ec2DescribeSecurityGroupRulesCommand, serializeAws_ec2DescribeSecurityGroupRulesCommand, } from "../protocols/Aws_ec2";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
/**
 * <p>Describes one or more of your security group rules.</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { EC2Client, DescribeSecurityGroupRulesCommand } from "@aws-sdk/client-ec2"; // ES Modules import
 * // const { EC2Client, DescribeSecurityGroupRulesCommand } = require("@aws-sdk/client-ec2"); // CommonJS import
 * const client = new EC2Client(config);
 * const command = new DescribeSecurityGroupRulesCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link DescribeSecurityGroupRulesCommandInput} for command's `input` shape.
 * @see {@link DescribeSecurityGroupRulesCommandOutput} for command's `response` shape.
 * @see {@link EC2ClientResolvedConfig | config} for command's `input` shape.
 *
 */
var DescribeSecurityGroupRulesCommand = /** @class */ (function (_super) {
    __extends(DescribeSecurityGroupRulesCommand, _super);
    // Start section: command_properties
    // End section: command_properties
    function DescribeSecurityGroupRulesCommand(input) {
        var _this = 
        // Start section: command_constructor
        _super.call(this) || this;
        _this.input = input;
        return _this;
        // End section: command_constructor
    }
    /**
     * @internal
     */
    DescribeSecurityGroupRulesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "DescribeSecurityGroupRulesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeSecurityGroupRulesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeSecurityGroupRulesResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeSecurityGroupRulesCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2DescribeSecurityGroupRulesCommand(input, context);
    };
    DescribeSecurityGroupRulesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2DescribeSecurityGroupRulesCommand(output, context);
    };
    return DescribeSecurityGroupRulesCommand;
}($Command));
export { DescribeSecurityGroupRulesCommand };
//# sourceMappingURL=DescribeSecurityGroupRulesCommand.js.map