import { __extends } from "tslib";
import { ModifySecurityGroupRulesRequest, ModifySecurityGroupRulesResult } from "../models/models_4";
import { deserializeAws_ec2ModifySecurityGroupRulesCommand, serializeAws_ec2ModifySecurityGroupRulesCommand, } from "../protocols/Aws_ec2";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
/**
 * <p>Modifies the rules of a security group.</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { EC2Client, ModifySecurityGroupRulesCommand } from "@aws-sdk/client-ec2"; // ES Modules import
 * // const { EC2Client, ModifySecurityGroupRulesCommand } = require("@aws-sdk/client-ec2"); // CommonJS import
 * const client = new EC2Client(config);
 * const command = new ModifySecurityGroupRulesCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link ModifySecurityGroupRulesCommandInput} for command's `input` shape.
 * @see {@link ModifySecurityGroupRulesCommandOutput} for command's `response` shape.
 * @see {@link EC2ClientResolvedConfig | config} for command's `input` shape.
 *
 */
var ModifySecurityGroupRulesCommand = /** @class */ (function (_super) {
    __extends(ModifySecurityGroupRulesCommand, _super);
    // Start section: command_properties
    // End section: command_properties
    function ModifySecurityGroupRulesCommand(input) {
        var _this = 
        // Start section: command_constructor
        _super.call(this) || this;
        _this.input = input;
        return _this;
        // End section: command_constructor
    }
    /**
     * @internal
     */
    ModifySecurityGroupRulesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "EC2Client";
        var commandName = "ModifySecurityGroupRulesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ModifySecurityGroupRulesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ModifySecurityGroupRulesResult.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ModifySecurityGroupRulesCommand.prototype.serialize = function (input, context) {
        return serializeAws_ec2ModifySecurityGroupRulesCommand(input, context);
    };
    ModifySecurityGroupRulesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_ec2ModifySecurityGroupRulesCommand(output, context);
    };
    return ModifySecurityGroupRulesCommand;
}($Command));
export { ModifySecurityGroupRulesCommand };
//# sourceMappingURL=ModifySecurityGroupRulesCommand.js.map